
var superdrag = {
	
	loaded: false,
	VERSION: 0.5,
	StartDragX: 0, StartDragY: 0, ver: 0, DownTarget: null,
	tabbrowser: null, RenderingArea: null,	
	PrefListener: {
		domain: "superdrag.",
		observe: function(subject, topic, prefName) {
			superdrag.init();
		}
	},

	PrefService: null, Pref: null, gadPbi: null,

	init: function() {  
		//GeckoVers = parseFloat(window.navigator.userAgent.substring(window.navigator.userAgent.lastIndexOf("rv:") + 3));

		if (!superdrag.loaded)	{
			window.removeEventListener("load", superdrag.init, false);
			superdrag.PrefService = Components.classes["@mozilla.org/preferences-service;1"]
		                     .getService(Components.interfaces.nsIPrefService);
			superdrag.Pref = superdrag.PrefService.getBranch("superdrag.");
			superdrag.gadPbi = superdrag.PrefService.getBranch(null).QueryInterface(Components.interfaces.nsIPrefBranchInternal);
			superdrag.gadPbi.addObserver(superdrag.PrefListener.domain, superdrag.PrefListener, false);
			var ver = superdrag.Pref.getCharPref("version");
			if (ver != superdrag.VERSION) {
				superdrag.Pref.setCharPref("version", superdrag.VERSION); 
				window.openDialog("chrome://superdrag/content/superdragSettings.xul", "superdragSettings", "chrome");
			}
			superdrag.tabbrowser = document.getElementById("content");
			superdrag.RenderingArea = superdrag.tabbrowser.mPanelContainer;
		
			superdrag.RenderingArea.addEventListener("mousedown", superdrag.downHandler, true);
			superdrag.tabbrowser.addEventListener("dragover", superdrag.dragOverHandler, false);
			superdrag.tabbrowser.addEventListener("drop", superdrag.dropHandler, false);
			contentAreaDNDObserver.onDragOver = superdrag.onDragOver;
			contentAreaDNDObserver.onDrop = superdrag.onDrop;
			nsDragAndDrop.checkCanDrop = superdrag.checkCanDrop;
			superdrag.loaded=true;
		}
	},

	onClose: function() {
		superdrag.gadPbi.removeObserver(superdrag.PrefListener.domain, superdrag.PrefListener);
		superdrag.RenderingArea.removeEventListener("mousedown", superdrag.downHandler, true);
		superdrag.tabbrowser.removeEventListener("dragover", superdrag.dragOverHandler, false);
		superdrag.tabbrowser.removeEventListener("drop", superdrag.dropHandler, false);
	},

	onDrop: function(aEvent, aXferData, aDragSession) {
		var xferData = aXferData.data.split("\n");
		var uri = xferData[0] ? xferData[0] : xferData[1];
		getBrowser().dragDropSecurityCheck(aEvent, aDragSession, uri); // is this necessary?
	  superdrag.ProcessDirectionalURI(uri,aEvent.screenX - superdrag.StartDragX,aEvent.screenY - superdrag.StartDragY);  
		aEvent.preventDefault(); aEvent.stopPropagation();  
	},

	ProcessDirectionalURI: function(uri, dx, dy) {
		if (!(uri)) return;
		var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		
		switch (document.firstChild.getAttribute('windowtype')) {
			case "navigator:browser":
				var toURI;
				try { 
					toURI = ios.newURI(uri, null, null); 
				} catch(err) { 
					try {
						toURI = ios.newURI("http://"+uri, null, null); 
					} catch(err) { 
					}
				}
				var openURL;
				// url test      			      			
				var DomainName = /(\w+(\-+\w+)*\.)+\w{2,7}/ ;
				var HasSpace = /\S\s+\S/;
				var forceAsURL = DomainName.test(uri) && (!HasSpace.test(uri));
				// JavaScript should always open in the same tab
				if (/^(javascript\:)/.test(uri)) {
					//DownTarget.click();
					break;
				}
	    	//force url or local file/directory 
				if (forceAsURL || (/^(file\:\/\/\/)/.test(uri))) 
				{ 
					//check if an external xpi file is dropped.
					if (/^(file\:\/\/\/)/.test(uri)&&/([^\/]+\.xpi)$/.test(uri)) {
						eval("InstallTrigger.install({ '" + RegExp.$1 + "' : uri })");                 		 		
						break;              			 	
					}   	
					openURL = uri;
				} else {
					//it's a text string, so search it
					var searchBar = document.getElementById('searchbar');
					if (!(searchBar)) return;
					if (searchBar.currentEngine) { // Fx2.0+
	    			var submission = searchBar.currentEngine.getSubmission(uri, null);
	    			if (submission) openURL = submission.uri.spec;
					} else { // Fx1.0-1.5
						var searchEngine = searchBar.getAttribute('searchengine');
						if (!searchEngine) return;
						var iSearchService = Components.classes['@mozilla.org/rdf/datasource;1?name=internetsearch'].getService(Components.interfaces.nsIInternetSearchService);
			  		openURL = iSearchService.GetInternetSearchURL(searchEngine, encodeURIComponent(uri), 0, 0, {value: 0});
					}
				}				
				// referrer: superdrag.tabbrowser.currentURI
				if ((Math.abs(dx)>2*Math.abs(dy))&&(dx<0)) break;
				if ((Math.abs(dx)>2*Math.abs(dy))||(getWebNavigation().currentURI.spec=="about:blank")) {
					loadURI(openURL,null,null);
					break;
				}
				var newTab = getBrowser().addTab(openURL);
				if (dy < 0) {
					getBrowser().selectedTab = newTab;
				}
				break;
				
			case "navigator:view-source":
				viewSource(uri);
				break;
		}
	},

	checkCanDrop: function(aEvent, aDragDropObserver) {
		if (!this.mDragSession)	this.mDragSession = this.mDragService.getCurrentSession();
		if (!this.mDragSession) return false;
		// The next line of code is used to allow dropping on the source node if the source node is an IMG element
		this.mDragSession.canDrop = this.mDragSession.sourceNode != aEvent.target;         
		if(this.mDragSession.sourceNode) if( this.mDragSession.sourceNode.nodeName == 'IMG')
			this.mDragSession.canDrop = true;               
		if ("canDrop" in aDragDropObserver)
			this.mDragSession.canDrop &= aDragDropObserver.canDrop(aEvent, this.mDragSession);
		return true;
	},

	onDragOver: function(aEvent, aFlavour, aDragSession) {
		aDragSession.canDrop=true;
		return true;
	},
	
	dragOverHandler: function(aEvent) {
		nsDragAndDrop.dragOver(aEvent, contentAreaDNDObserver);
	},
	
	dropHandler: function(aEvent) {
		nsDragAndDrop.dragOver(aEvent, contentAreaDNDObserver);
	},
	
	downHandler: function(aEvent) {
		superdrag.DownTarget = aEvent.originalTarget;
		superdrag.StartDragY = aEvent.screenY; superdrag.StartDragX = aEvent.screenX;	
	},

	upHandler: function(aEvent) {
		DownTarget=null;  
	},
	
  getSupportedFlavours: function () {
		var flavourSet = new FlavourSet();
		flavourSet.appendFlavour("text/x-moz-url");
		flavourSet.appendFlavour("text/unicode");
		flavourSet.appendFlavour("application/x-moz-file", "nsIFile");
		return flavourSet;
	}
};

/*

    function doSearch(aData, aInNewTab) {
    var postData = null;
    var submission = superdrag.currentEngine.getSubmission(aData, null);
    if (submission) {
        var url = submission.uri.spec;
        postData = submission.postData;
    }
    if (aInNewTab) {
        content.focus();
        getBrowser().loadOneTab(url, null, null, postData, false, false);
        if (gURLBar) {
            gURLBar.value = url;
        }
    } else {
        loadURI(url, null, postData, false);
    }
    content.focus();
}
  */